'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /**
                                                                                                                                                                                                                                                                   * You can use this field as array field but the main purporse is to extend it
                                                                                                                                                                                                                                                                   * and create your own (like the material-ui fields do)
                                                                                                                                                                                                                                                                   */

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _ArrayContextItem = require('./ArrayContextItem');

var _ArrayContextItem2 = _interopRequireDefault(_ArrayContextItem);

var _utility = require('../utility');

var _FieldType = require('../FieldType');

var _generateInputsForKeys = require('../utility/generateInputsForKeys');

var _generateInputsForKeys2 = _interopRequireDefault(_generateInputsForKeys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = _extends({}, _FieldType.propTypes, {
  /**
   * The add button label
   */
  addLabel: _react2.default.PropTypes.string,

  /**
   * Show the add button
   */
  showAddButton: _react2.default.PropTypes.bool,

  /**
   * The remove label
   */
  removeLabel: _react2.default.PropTypes.string,

  /**
   *
   */
  autoAddItem: _react2.default.PropTypes.bool,

  /**
   * The label for the field
   */
  label: _react2.default.PropTypes.string,

  /**
   * Each item component
   */
  children: _react2.default.PropTypes.any,

  /**
   * Pass a function that returns the children components for the current item.
   * The inputs of the function will be value and index.
   * This is useful when you want to change the view of a item in the array depending
   * on the current value.
   */
  renderItem: _react2.default.PropTypes.func
});

var defaultProps = {
  addLabel: 'Add',
  removeLabel: 'Remove',
  showLabel: true,
  errorMessages: {},
  autoAddItem: false,
  showAddButton: true
};

var childContextTypes = {
  parentFieldName: _react2.default.PropTypes.string
};

var ArrayComponent = function (_React$Component) {
  _inherits(ArrayComponent, _React$Component);

  function ArrayComponent() {
    _classCallCheck(this, ArrayComponent);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(ArrayComponent).apply(this, arguments));
  }

  _createClass(ArrayComponent, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        parentFieldName: this.props.fieldName
      };
    }
  }, {
    key: 'addItem',
    value: function addItem() {
      var itemValue = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      var newArray = this.props.value;
      if (_underscore2.default.isArray(newArray)) {
        newArray.push(itemValue);
      } else {
        newArray = [itemValue];
      }

      this.props.onChange(newArray);
    }
  }, {
    key: 'removeItem',
    value: function removeItem(index) {
      var value = this.props.value || [];
      var newArray = _underscore2.default.without(value, value[index]);
      this.props.onChange(newArray);
    }
  }, {
    key: 'getChildrenComponents',
    value: function getChildrenComponents(item, index) {
      if (this.props.renderItem) return this.props.renderItem(item, index);
      if (this.props.children) return this.props.children;
      if (!this.props.schema) throw new Error('You must pass children to the array field "' + this.props.fieldName + '"');
      var schemaFieldName = (0, _utility.replaceIndexKeys)(this.props.fieldName);
      var keys = this.props.schema.objectKeys(schemaFieldName + '.$');
      return (0, _generateInputsForKeys2.default)(keys, schemaFieldName + '.$', this.props.schema, this.props.omit);
    }
  }, {
    key: 'renderChildren',
    value: function renderChildren() {
      var _this2 = this;

      var value = this.props.value || [];
      if (this.props.autoAddItem && !this.props.disabled && value.length === 0) {
        value.push({});
      }
      return value.map(function (item, index) {
        var children = _this2.getChildrenComponents(item, index);
        return _this2.renderChildrenItem({ index: index, children: children });
      });
    }
  }, {
    key: 'renderChildrenItem',
    value: function renderChildrenItem(_ref) {
      var _this3 = this;

      var index = _ref.index;
      var children = _ref.children;

      return _react2.default.createElement(
        'div',
        { style: { marginTop: 20, marginBottom: 20, padding: 20 }, key: this.props.fieldName + '.' + index },
        this.renderChildrenItemWithContext({ index: index, children: children }),
        _react2.default.createElement(
          'div',
          { style: { marginTop: 10, textAlign: 'right' } },
          _react2.default.createElement(
            'button',
            { type: 'button', onClick: function onClick() {
                return _this3.removeItem(index);
              } },
            this.props.removeLabel
          )
        )
      );
    }
  }, {
    key: 'renderChildrenItemWithContext',
    value: function renderChildrenItemWithContext(_ref2) {
      var index = _ref2.index;
      var children = _ref2.children;

      return _react2.default.createElement(
        _ArrayContextItem2.default,
        { index: index, fieldName: this.props.fieldName },
        children
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      return _react2.default.createElement(
        'div',
        { style: { marginTop: 20 } },
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            'b',
            null,
            this.props.label
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { color: 'red' } },
          this.props.errorMessage
        ),
        this.renderChildren(),
        _react2.default.createElement(
          'div',
          { style: { marginTop: 10 } },
          _react2.default.createElement(
            'button',
            { type: 'button', onClick: function onClick() {
                return _this4.addItem();
              } },
            this.props.addLabel
          )
        )
      );
    }
  }]);

  return ArrayComponent;
}(_react2.default.Component);

exports.default = ArrayComponent;


ArrayComponent.propTypes = propTypes;
ArrayComponent.defaultProps = defaultProps;
ArrayComponent.childContextTypes = childContextTypes;