'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FieldType = require('./FieldType');

var _utility = require('./utility');

var _generateInputsForKeys = require('./utility/generateInputsForKeys');

var _generateInputsForKeys2 = _interopRequireDefault(_generateInputsForKeys);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * You can use this field as array field but the main purporse is to extend it
 * and create your own (like the material-ui fields do)
 */

var propTypes = _extends({}, _FieldType.propTypes, {
  /**
  * Each item component
  */
  children: _react2.default.PropTypes.any
});

var childContextTypes = {
  parentFieldName: _react2.default.PropTypes.string
};

var ObjectComponent = function (_React$Component) {
  _inherits(ObjectComponent, _React$Component);

  function ObjectComponent() {
    _classCallCheck(this, ObjectComponent);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(ObjectComponent).apply(this, arguments));
  }

  _createClass(ObjectComponent, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        parentFieldName: this.props.fieldName
      };
    }
  }, {
    key: 'getChildrenComponents',
    value: function getChildrenComponents() {
      if (this.props.children) return this.props.children;
      if (!this.props.schema) throw new Error('You must pass children to the object field "' + this.props.fieldName + '"');
      var schemaFieldName = (0, _utility.replaceIndexKeys)(this.props.fieldName);
      var keys = this.props.schema.objectKeys(schemaFieldName);
      return (0, _generateInputsForKeys2.default)(keys, schemaFieldName, this.props.schema, this.props.omit);
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        { style: { marginTop: 20, marginBottom: 20, padding: 20 } },
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            'b',
            null,
            this.props.label
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { color: 'red' } },
          this.props.errorMessage
        ),
        this.getChildrenComponents()
      );
    }
  }]);

  return ObjectComponent;
}(_react2.default.Component);

exports.default = ObjectComponent;


ObjectComponent.propTypes = propTypes;
ObjectComponent.childContextTypes = childContextTypes;