'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

var _Form = require('../Form');

var _Form2 = _interopRequireDefault(_Form);

var _SchemaStub = require('./SchemaStub');

var _SchemaStub2 = _interopRequireDefault(_SchemaStub);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DummyInput = function (_React$Component) {
  _inherits(DummyInput, _React$Component);

  function DummyInput() {
    _classCallCheck(this, DummyInput);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(DummyInput).apply(this, arguments));
  }

  _createClass(DummyInput, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement('input', { name: this.props.fieldName });
    }
  }]);

  return DummyInput;
}(_react2.default.Component);

test('Should generate input keys correctly based on the schema', function () {
  var schema = new _SchemaStub2.default({
    name: {
      type: String,
      srf: {
        type: DummyInput
      }
    },
    ignoreMeSenpai: {
      type: Number,
      srf: {
        type: DummyInput,
        omit: true
      }
    }
  });
  var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_Form2.default, { schema: schema }));
  var result = wrapper.html();
  var expected = '<form><input name="name"></form>';
  expect(result).toBe(expected);
});